#!/usr/bin/python
import numpy as np
import math
import matplotlib
from matplotlib import pyplot as plt

#code to make plot of Simulated annealing results
optfilename = "C:\\Users\\Jake\\Documents\\SMA\\mldiel\\SMAwindow_2layer_run1.txt"

#import data from file

fin = open(optfilename,'r')

recparamarray = []
recoptimizearray = []
maxoptimizearray = []
recstepnumarray = []
maxstepnumarray = []
stepnum = 0
for line in fin:
	datavector = line.split(" ")
	recstepnumarray.append(stepnum)
	paramdata = []
	for i in range(0,len(datavector) - 1):
		paramdata.append(float(datavector[i]))
	recparamarray.append(paramdata)
	recoptimizearray.append(float(datavector[len(datavector)-1]))
	if stepnum == 0:
		maxstepnumarray.append(stepnum)
		maxoptimizearray.append(float(datavector[len(datavector)-1]))
	elif float(datavector[len(datavector)-1]) >= maxoptimizearray[len(maxoptimizearray)-1]:
		maxstepnumarray.append(stepnum)
		maxoptimizearray.append(float(datavector[len(datavector)-1]))
	stepnum = stepnum + 1
	
fin.close()

#figures for plot
fig1 = plt.figure(1)
ax11 = fig1.add_subplot(231)
plt.ylim((0,30))
ax12 = fig1.add_subplot(232)
plt.ylim((0,30))
ax13 = fig1.add_subplot(233)
plt.ylim((0,30))
ax14 = fig1.add_subplot(234)
plt.ylim((0,30))
ax15 = fig1.add_subplot(235)
plt.ylim((0,30))
ax16 = fig1.add_subplot(236)
plt.ylim((0,30))

t = np.arange(len(recoptimizearray))

ax11.plot(recstepnumarray,recoptimizearray,'-r')
ax11.plot(maxstepnumarray,maxoptimizearray,'-b')
ax11.set_xlabel('Step Number')
ax11.set_ylabel('Return Loss (dB)')

#ax12.cla()
ax12.scatter(np.array(recparamarray)[:,0],recoptimizearray,c=t,s=12,edgecolor='none')
ax12.set_xlabel('Art1 FF')
ax12.set_ylabel('Return Loss (dB)')
#ax12.set_xlim(ranges[0])
		
#ax13.cla()
ax13.scatter(np.array(recparamarray)[:,1],recoptimizearray,c=t,s=12,edgecolor='none')
ax13.set_xlabel('Art1 Thickness (um)')
ax13.set_ylabel('Return Loss (dB)')
#ax13.set_xlim(ranges[1])
		
#ax14.cla()
ax14.scatter(np.array(recparamarray)[:,2],recoptimizearray,c=t,s=12,edgecolor='none')
ax14.set_xlabel('Art2 FF')
ax14.set_ylabel('Return Loss (dB)')
#ax14.set_xlim(ranges[2])
	
#ax15.cla()
ax15.scatter(np.array(recparamarray)[:,3],recoptimizearray,c=t,s=12,edgecolor='none')
ax15.set_xlabel('Art2 Thickness (um)')
ax15.set_ylabel('Return Loss (dB)')
#ax15.set_xlim(ranges[3])

#ax16.cla()
ax16.scatter(np.array(recparamarray)[:,4],recoptimizearray,c=t,s=12,edgecolor='none')
ax16.set_xlabel('Silicon Thickness (um)')
ax16.set_ylabel('Return Loss (dB)')
#ax16.set_xlim(ranges[4])

plt.show()