#!/usr/bin/python
import numpy as np
import math
import cmath

def calcSparams(stack,freq):
	e0 = 8.85418782*1e-12
	mu0 = 4*math.pi*1e-7
	#print(1/math.sqrt(e0*mu0))
	propcon = []
	impedance = []
	cond = []
	for i in range(0,len(stack)):
		propcon.append(1j*freq*2*math.pi*cmath.sqrt(e0*complex(stack[i][1])*mu0*complex(stack[i][2]))*cmath.sqrt(1-1j*complex(stack[i][4])-1j*complex(stack[i][5])/(2*math.pi*freq*e0*complex(stack[i][1]))))
		#impedance.append(cmath.sqrt((mu0*complex(stack[i][2]))/(e0*complex(stack[i][1]))))
		impedance.append(1j*2*math.pi*freq*mu0*complex(stack[i][2])/propcon[i])
	propcon = np.array(propcon)
	impedance = np.array(impedance)
	#print(propcon)
	tmat = [[1,0],[0,1]]
	tmat = np.array(tmat)
	for i in range(1,len(stack)-1):
		#print(i)
		#print(1j/propcon[i])
		gl = propcon[i]*float(stack[i][3])
		#print(gl)
		#print(cmath.cosh(gl))
		layermat = [[cmath.cosh(gl),impedance[i]*cmath.sinh(gl)],[1/impedance[i]*cmath.sinh(gl),cmath.cosh(gl)]]
		layermat = np.array(layermat)
		#print(layermat)
		tmat = np.dot(tmat,layermat)
	#print(tmat)
	A = tmat[0][0]
	B = tmat[0][1]
	C = tmat[1][0]
	D = tmat[1][1]
	#print(A)
	#print(B)
	#print(C)
	#print(D)
	#print(A*D-B*C)
	n1 = impedance[0]
	nn = impedance[len(impedance)-1]
	S11 = (A+B/nn-n1*C-n1/nn*D)/(A+B/nn+n1*C+n1/nn*D)
	S12 = 2.0*n1/nn*(A*D-B*C)/(A+B/nn+n1*C+n1/nn*D)
	S21 = 2.0/(A+B/nn+n1*C+n1/nn*D)
	S22 = (-A+B/nn-n1*C+n1/nn*D)/(A+B/nn+n1*C+n1/nn*D)
	smat = [[S11,S12],[S21,S22]]
	smat = np.array(smat)
	return smat
	
def calcBandAve(dielstack,freqs):
	s11ave = 0
	s12ave = 0
	s21ave = 0
	s22ave = 0
	for freq in freqs:
		smatrix = calcSparams(dielstack,freq*1e9)
		s11ave = s11ave + 1/len(freqs)*np.absolute(smatrix[0][0])
		s12ave = s12ave + 1/len(freqs)*np.absolute(smatrix[0][1])
		s21ave = s21ave + 1/len(freqs)*np.absolute(smatrix[1][0])
		s22ave = s22ave + 1/len(freqs)*np.absolute(smatrix[1][1])
	BandAvemat = [[s11ave,s12ave],[s21ave,s22ave]]
	BandAvemat = np.array(BandAvemat)
	return BandAvemat
