#!/usr/bin/python
import numpy as np
import math
import cmath
import matplotlib
from matplotlib import pyplot as plt
import sys
import time
import mldiel

freqs = np.linspace(200,400,201)
s11 = []
s12 = []
s21 = []
s22 = []
artthicks = np.linspace(1,1000,1000)
for artthick in artthicks:
	dielstack = []

	#make dielectric stack: name, epsilon_r, mu_r, thickness (m)
	airlayer = ['air',1,1,-1]
	ldpelayer = ['ldpe',2.3,1,159e-6]
	artdiellayer = ['artdiel',6.95,1,artthick*1e-6]
	siliconlayer = ['silicon',11.42,1,3e-3]

	dielstack.append(airlayer)
	dielstack.append(ldpelayer)
	dielstack.append(artdiellayer)
	dielstack.append(siliconlayer)
	dielstack.append(artdiellayer)
	dielstack.append(ldpelayer)
	dielstack.append(airlayer)
	dielstack = np.array(dielstack)
	
	bandaves = mldiel.calcBandAve(dielstack,freqs)
	
	s11.append(10*math.log10(bandaves[0][0]))
	s12.append(10*math.log10(bandaves[0][1]))
	s21.append(10*math.log10(bandaves[1][0]))
	s22.append(10*math.log10(bandaves[1][1]))
	
s11 = np.array(s11)
s12 = np.array(s12)
s21 = np.array(s21)
s22 = np.array(s22)

fig1 = plt.figure(1)
ax11 = fig1.add_subplot(221)
ax12 = fig1.add_subplot(222)
ax13 = fig1.add_subplot(223)
ax14 = fig1.add_subplot(224)

ax11.plot(artthicks,s11)
ax12.plot(artthicks,s12)
ax13.plot(artthicks,s21)
ax14.plot(artthicks,s22)

plt.show()	